;****************************************************************************
;*
;*                        The Universal VESA VBE
;*
;*                  Copyright (C) 1993 Kendall Bennett.
;*                          All rights reserved.
;*
;* Filename:    $RCSfile: _avance.asm $
;* Version:     $Revision: 1.1 $
;*
;* Language:    8086 Assembler
;* Environment: IBM PC (MS DOS)
;*
;* Description: Assembly language support routines for Avance Logic AL2101
;*              SuperVGA's.
;*
;*              Contains code to perform initialisation, bank switching
;*              and extended page flipping if possible.
;*
;* $Id: _avance.asm 1.1 1993/09/19 01:26:40 kjb Exp $
;*
;* Revision History:
;* -----------------
;*
;* $Log: _avance.asm $
;* Revision 1.1  1993/09/19  01:26:40  kjb
;* Initial revision
;*
;****************************************************************************

;----------------------------------------------------------------------------
; AVANCE_bank   Change to a new 64k bank (reading and writing)
;----------------------------------------------------------------------------
;
; Entry:        AX  - Number of 64k bank
;
; Registers:    All preserved!
;
;----------------------------------------------------------------------------
PROC    AVANCE_bank far

        cli
        push    ax
        push    dx
        mov     dx,3D6h
        out     dx,al               ; Set read bank register
        inc     dx
        out     dx,al               ; Set write bank
        pop     dx
        pop     ax
        sti
        ret

ENDP    AVANCE_bank

AVANCE_bank_len =   ($-AVANCE_bank)

;----------------------------------------------------------------------------
; AVANCE_init
;----------------------------------------------------------------------------
; We have an Advance Logic 2101 SuperVGA, so set up for separate read
; write bank switching. This is supposed to work according to the
; docs on the AVANCE, but it doesn't (it works for the RealTek instead!)
; Very wierd!!
;----------------------------------------------------------------------------
PROC    AVANCE_init

        mov     [TwoBanks],false
        mov     [WriteBank16],offset AVANCE_bank
        mov     [WriteBank16Len],AVANCE_bank_len
        mov     [WriteBank256],offset AVANCE_bank
        mov     [WriteBank256Len],AVANCE_bank_len
        ret

ENDP    AVANCE_init

